<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class clsmain
{
protected $site;
protected $list_perpage=50;
protected $adminLogin=false;
protected $con;
function __construct()
{
        $message=$this->connection();
		if($message!==true){echo $message;exit;}
}
private function connection()
{
        include '../database/config.php';
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return true;
}
protected function validate_user(&$message='')
{
		if($this->validate_pw($message)){$this->adminLogin=true;return true;}
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result=$this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        if(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login'])){$this->adminLogin=true;return true;}
		return false;
}
private function validate_pw(&$message='')
{
        if(empty($_POST['password'])||empty($_POST['name'])){return false;}
        $_SESSION['fw_try']=((isset($_SESSION['fw_try']))? 1+$_SESSION['fw_try'] : 1);
        if($_SESSION['fw_try'] > 5){$message='<div style="background:#883333; font-size:12px; clear:both; padding:5px; color:#ffffff;">Login session exceed! Please restart your browser to start new session</div>';return false;}
        $name=bin2hex(htmlspecialchars(fw_strip_slashes(trim($_POST['name']))));
        $pass=md5(fw_strip_slashes(trim($_POST['password'])));
        $query ="SELECT* FROM ".PREFIX."admin";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if(($pass==$row['password'])&&($name==bin2hex($row['user']))){
            $random=fw_random();
            $random=substr($random,0,12);
            $_SESSION['fw_admin']=$random;
            $_SESSION['fw_try']=0;
            $addr=$_SERVER["REMOTE_ADDR"];
            $query="UPDATE ".PREFIX."admin SET login = '$addr', session = '$random'";
            if(@$this->con->query($query)!==false){return true;}
        }
}
protected function log_out()
{
        unset($_SESSION['fw_admin']);
		$this->adminLogin=false;
		$query = "UPDATE ".PREFIX."admin SET login ='' AND session =''";
		@$this->con->query($query);
        $this->log_in();
}
protected function log_in(&$message='')
{
        if(file_exists("../database/newlogin.php")){
              $this->update_password();
              $message='<div style="background:#444444; font-size:12px;clear:both; padding:5px; color:#eeeeee;"><b>Your user name and password has been updated.</b></div>';}
		$this->build_head("Login",'<script type="text/javascript" src="script/admin.js"></script>','');
        include "include/login.php";
        $this->build_footer();
}
protected function build_head($title, $script='',$hmenu)
{
        if($this->adminLogin){
			$leftmenu= '<table class="fw_leftmenu" cellspacing="3"><tr><td><img src="images/forum.gif" /></td><td><a href="index.php?qur=11M">Manage forums And Categories</a></td></tr>';
            $query="SELECT tp.p, tc.c FROM (SELECT IF(ISNULL(COUNT(id)),0,COUNT(id)) AS p FROM ".PREFIX."post WHERE pid = 0 AND fid <> 0 AND publish = '') AS tp LEFT JOIN (SELECT IF(ISNULL(COUNT(id)),0,COUNT(id)) AS c FROM ".PREFIX."post WHERE pid <> 0 AND publish = '') AS tc ON TRUE";
			$result=@$this->con->query($query);
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$leftmenu.= '<tr><td><img src="images/post.gif" /></td><td><a href="index.php?qur=2M">Edit post:<br />'.(($row['p']==0)? 'No post is waiting for approval': '<b>'.$row['p']. '</b> post'.(($row['p']>1)? 's are waiting for approval':' is waiting for approval')).'</a></td></tr>';
            $leftmenu.= '<tr><td><img src="images/comments.gif" /></td><td><a href="index.php?qur=9M">Edit comments:<br />'.(($row['c']==0)? 'No comment is waiting for approval': '<b>'.$row['c']. '</b> comment'.(($row['c']>1)? 's are waiting for approval':' is waiting for approval')).'</a></td></tr>';
			unset($row);
			@$result->free();
			$leftmenu.= '<tr><td><img src="images/page.gif" /></td><td><a href="index.php?qur=1M">Create new or edit existing HTML Pages</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/news.gif" /></td><td><a href="index.php?qur=14M">Post news or edit existing News Pages</a></td></tr>';
            $leftmenu.= '<tr><td><img src="images/users.gif" /></td><td><a href="index.php?qur=3M">Manage users</a></td></tr>';
            $query="SELECT ti.m, tr.r FROM (SELECT IF(ISNULL(COUNT(id)),0,COUNT(id)) AS m FROM ".PREFIX."inbox WHERE new = 1) AS ti LEFT JOIN (SELECT IF(ISNULL(COUNT(id)),0,COUNT(id)) AS r FROM ".PREFIX."report WHERE new = 1) AS tr ON TRUE";
			$result=@$this->con->query($query);
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$leftmenu.='<tr><td><img src="images/inbox.gif" /></td><td><a href="index.php?qur=4M">Read messages:<br />'.(($row['m']==0)? 'You have no unread message': 'You have <b>'.$row['m']. '</b> unread'.(($row['m']>1)? ' messages':' message')).'</a></td></tr>';
			$leftmenu.='<tr><td><img src="images/report.gif" /></td><td><a href="index.php?qur=5M">Viewers reports:<br />'.(($row['r']==0)? 'You have no unread report': 'You have <b>'.$row['r']. '</b> unread'.(($row['r']>1)? ' reports':' report')).'</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/admin.gif" /></td><td><a href="index.php?qur=6M8">Edit your email and login information</a></td></tr>';
			$leftmenu.='<tr><td><img src="images/upload.gif" /></td><td><a href="index.php?qur=8M">Upload new file for your HTML pages</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/settings.gif" /></td><td><a href="index.php?qur=6M1M">Edit script settings, - how it appears in the internet world</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/sitemap.gif" /></td><td><a href="index.php?qur=6M10">Generate XML Sitemap for Search Engines</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/template.gif" /></td><td><a href="index.php?qur=7M">Upload new templates or edit template files</a></td></tr>';
			$leftmenu.= '<tr><td><img src="images/logout.gif" /></td><td><a href="index.php?qur=0M5M">Logout from your script control panel</a></td></tr></table>';
        }
        else{
            $hmenu= '<li><a href="index.php">Login</a></li>';
            $hmenu.= '<li><a href="index.php?qur=99M2">Forget password</a></li>';
        }
        include "include/head.php";
}
protected function build_footer()
{
        include "include/footer.html";
        exit;
}
private function forget_password()
{
        if((empty($_POST['newname']))||(empty($_POST['newpw']))){
             $this->build_head("Forget password",'<script type="text/javascript" src="script/forget.js"></script>','');
             include "include/forget.php";
             $this->build_footer();
        }
        else{
             $s='<?php exit; ?>'."\n";
             $s.='//Do not edit this file. Please upload it to your '.DOCROOT.'gb/database/ directory of your web server.'."\n";
             $s.=$_POST['newname'].'< >'.md5(fw_strip_slashes($_POST['newpw']));
             $filename='newlogin.php';
             @header("Content-type: application/text");
             @header("Content-Disposition: attachment; filename=$filename");
             echo $s;
        }
}
private function update_password()
{
        if(($lines=@file("../database/newlogin.php"))===false){return;}
        $data=explode('< >',$lines[2]);
        $newuser=$data[0];
        $newpassword=trim($data[1]);
        $query="UPDATE ".PREFIX."admin SET user = '$newuser', password = '$newpassword'";
        @$this->con->query($query);
        @unlink("../database/newlogin.php");
}
public function get_query($query='')
{
    $message='';
	if ($this->validate_user($message)){
		switch ($query[1]) {
		case "5":
		  $this->log_out();
		break;
		case "4":
		  $this->show_admin();
		break;
		case "1":
		  $this->show_mail();
		break;
		case "3":
			$this->delete_uploadfile($query[2],$query[3]);
		break;
		case "6":
			$this->upload_file($query[2]);
		break;
		default :
		  $this->show_admin();}
    }
    else{
        switch($query[1]){
			case "2":
				$this->forget_password();
			break;
			default :
				$this->log_in($message);
			}
		}
}
private function show_admin()
{
		$this->build_head("Admin center", '','');
		include 'include/admin.html';
		$this->build_footer();
}
private function show_mail(){
		$result=@$this->con->query("SELECT* FROM ".PREFIX."mailsettings");
		$row = @$result->fetch_array(MYSQL_ASSOC);
		$email=fw_strip_slashes($_GET['email']);
		include 'include/contactform.php';
}
protected function clear_userfiles()
{
		$lasthour=time()-3600;
		$result=@$this->con->query("SELECT pname FROM ".PREFIX."upload WHERE (pid = 0 AND uid = 0) OR (pid = 0 AND date < $lasthour)");
		while($row = @$result->fetch_array(MYSQL_ASSOC)){@unlink(USER_FILES.'.'.$row['pname']);}
		@$this->con->query(sprintf("DELETE FROM ".PREFIX."upload WHERE (pid = 0 AND uid = %u) OR (pid = 0 AND date < $lasthour)",$this->uid));
}
protected function get_uploadlist($us,$pid=0)
{
		$str='<tr><td id="fw_uploadfiles"><table>';
		$query=sprintf("SELECT id, name, pid FROM ".PREFIX."upload WHERE (uid = 0 AND pid = 0) OR pid = %u",$pid);
		$result=@$this->con->query($query);
		$num_rows=@$result->num_rows;
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			$str.='<tr><td  class="fw_filename" id="'.$row['id'].'" width="60%">';
			$str.=(($row['pid'])? '*':'').$row['name'].'</td><td style="text-align:center;"><a title="Add to post" class="btn_add" href="javascript:addFileA(\''.addslashes($row['name']).'\')">Add</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a title="Remove from post" class="btn_remove" href="javascript:removeFileA(\''.addslashes($row['name']).'\')">Remove</a>';
			$str.='&nbsp;&nbsp;|&nbsp;&nbsp;<a title="Parmanently delete" class="btn_delete" href="javascript:deleteFileA('.$row['id'].',\''.addslashes($row['name']).'\')">Delete</a></td></tr>';
		}
		$str.='</table></td><td id="fw_notice"><ul><li>Maximum file size: '.$us['size'].'Kb;</li><li>Allowed file type: '.$us['extensions'].';</li><li>Valid file name: A-Z, a-z, 0-9, \'-\', \'_\';</li></ul></td></tr>';
		$str.='<tr><td colspan="2" id="tdUpload">';
		if($num_rows<$us['fpp']){
			$str.='<form name="frmUpload" enctype="multipart/form-data" target="fileSubmit" action="index.php?qur=99M6M'.$pid.'" method="POST" onSubmit="return fwCheckSubmit(this,\''.$us['extensions'].'\');">';
			$str.='<input type="hidden" name="MAX_FILE_SIZE" value="'.($us['size']*1024).'" />';
			$str.='<input name="file" type="file" />&nbsp;&nbsp;<input name="submit" type="submit" value="Upload File" /></form>';
		}
		else{$str.='**Please Delete unnecessary files to upload new file';}
		return $str.'</td></tr>';
}
protected function delete_uploadfile($id,$pid)
{
		$result=@$this->con->query(sprintf("SELECT pname FROM ".PREFIX."upload WHERE id = %u",$id));
		$row = @$result->fetch_array(MYSQL_ASSOC);
		@unlink(USER_FILES.'.'.$row['pname']);
		@$this->con->query(sprintf("DELETE FROM ".PREFIX."upload WHERE id = %u",$id));
		echo '<script>parent.document.getElementById("fw_uploadlist").innerHTML="'.fw_php2javascript($this->get_uploadlist($this->get_uploadsettings(),$pid)).'";</script>';
}
private function get_filecount($pid)
{
		$query="SELECT id, name FROM ".PREFIX."upload WHERE (uid = 0 AND pid = 0)";
		if($pid){$query.=sprintf(" OR (pid = %u)",$pid);}
		$result=@$this->con->query($query);
		return @$result->num_rows;
}
private function upload_exists($n,$pid)
{
		$query=sprintf("SELECT id FROM ".PREFIX."upload WHERE ((uid = 0 AND pid = 0) OR pid = %u) AND name = '$n'",$pid);
		$result=@$this->con->query($query);
		return @$result->num_rows;
}
protected function get_uploadsettings()
{
		$result=@$this->con->query("SELECT* FROM ".PREFIX."filesettings LIMIT 0, 1");
		return @$result->fetch_array(MYSQL_ASSOC);
}
private function upload_file($pid)
{
		$us=$this->get_uploadsettings();
		if($us['fpp']<=$this->get_filecount($pid)){exit;}
		if(!(is_uploaded_file($_FILES["file"]["tmp_name"]))){exit;}
		if($_FILES["file"]["size"] > ($us['size'])*1024){exit;}
		if(!fw_validate_filename(($_FILES["file"]["name"]),$us['extensions'])){echo '<script>alert("Invalid file name or extension!");</script>';return;}
		if($this->upload_exists(($_FILES["file"]["name"]),$pid)){echo '<script>alert("File already exists!");</script>';return;}
		$pname='';
		while((empty($pname))||(is_file(USER_FILES.'.'.$pname))){$pname=fw_generate_filename();}
		$date=time();
		$size=getimagesize($_FILES["file"]["tmp_name"]);
		if(($size===false)||(!preg_match('/^([a-z0-9_\-]){1,45}+(\.)+(gif|png|jpg|bmp|jpeg)$/i',$_FILES["file"]["name"]))){
			$zip = new ZipArchive;
			if($zip->open(USER_FILES.'.'.$pname,ZipArchive::CREATE) === TRUE){
				if($zip->addFile(($_FILES["file"]["tmp_name"]), ($_FILES["file"]["name"]))){
					$zip->close();
					chmod(USER_FILES.'.'.$pname,0666);
					$filesize=@filesize(USER_FILES.'.'.$pname);
					$query="INSERT INTO ".PREFIX."upload (uid, pname, name, type, filesize, date, compressed) VALUES (0, '%s', '%s', '%s', %d, $date, 1)";
					$query=sprintf($query,$this->con->real_escape_string($pname),$this->con->real_escape_string($_FILES["file"]["name"]),$this->con->real_escape_string($_FILES["file"]["type"]),$filesize);
					@$this->con->query($query);
				}
				else{$zip->close();}
			}
		}
		else{
			if(($size[0]>$us['width'])||($size[1]>$us['height'])){echo '<script>alert("Max image size w X h = '.$us['width'].' X '.$us['height'].'");</script>';return;}
			if(@move_uploaded_file(($_FILES["file"]["tmp_name"]),(USER_FILES.'.'.$pname))){
				$query="INSERT INTO ".PREFIX."upload (uid, pname, name, type, filesize, date, compressed) VALUES (0, '%s', '%s', '%s', %d, $date, 0)";
				$query=sprintf($query,$this->con->real_escape_string($pname),$this->con->real_escape_string($_FILES["file"]["name"]),$this->con->real_escape_string($_FILES["file"]["type"]),($_FILES["file"]["size"]));
				@$this->con->query($query);
			}
		}
		echo '<script>parent.document.getElementById("fw_uploadlist").innerHTML="'.fw_php2javascript($this->get_uploadlist($us,$pid)).'";</script>';
}
protected function verify_uploadcontent(&$content,&$list,&$msg,$id)
{
		$arr=array();
		$us=$this->get_uploadsettings();
		$match='/\[file\]([a-z0-9_\-\.]){5,50}\[\/file\]/i';
		$x=preg_match_all($match,$content,$arr,PREG_PATTERN_ORDER);
		if($x){
			if($x>$us['fpp']){$msg='Exceed Max. file per post';return false;}
			$arr=array_unique($arr[0]);
			if(count($arr)<$x){$msg='Same file added more than once';return false;}
			foreach($arr as &$a){$a= "'".$this->con->real_escape_string(str_replace('[file]','',str_replace('[/file]','',$a)))."'";}
			$listx=implode(", ",$arr);
			$query=sprintf("SELECT id FROM ".PREFIX."upload WHERE name IN ($listx) AND ((uid = 0 AND pid = 0) OR pid = %u)",$id);
			$result=@$this->con->query($query);
			$n=@$result->num_rows;
			if($n<$x){$msg='Unknown file source';return false;}
			$ids=array();
			while($row = @$result->fetch_array(MYSQL_ASSOC)){$ids[]=(int)$row['id'];}
			$list='('.implode(', ',$ids).')';
			@$this->con->query("UPDATE ".PREFIX."upload SET pid = 0 WHERE pid = $id AND id NOT IN $list");
		}
		else{@$this->con->query("UPDATE ".PREFIX."upload SET pid = 0 WHERE pid = $id");}
		return true;
}
}
?>