<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class post extends clsmain
{
private function show_edit($post_id)
{
		$query="SELECT tp.*, tu.user, tf.title AS forum_title, IF(ISNULL(tc.cc), 0,tc.cc) AS c FROM ";
		$query.=PREFIX."post tp LEFT JOIN ".PREFIX."user tu ON tp.uid=tu.id LEFT JOIN ";
		$query.="(SELECT COUNT(id) AS cc, pid FROM ".PREFIX."post WHERE pid <>0 GROUP BY pid) AS tc ON tp.id=tc.pid LEFT JOIN ".PREFIX."forum tf ON tp.fid = tf.id WHERE ";
		$query.="tp.id = $post_id AND tp.fid <> 0";
		$result = @$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		if(empty($row['id'])){@header("Location: index.php?qur=2M");exit;}
		$max=sprintf("%d",$this->site['postsize']);
		$forum_list=$this->show_listy($row['fid']);
		$hmenu='<li><a href="index.php?qur=2M">Post list</a></li><li><a href="javascript:fwPublish()"><span id="fw_block">'.(($row['publish']=='Y')? 'Block' : 'Publish').'</span></a></li>';
		$hmenu.='<li><a href="javascript:fwLock()"><span id="fw_lock">'.(($row['locked']=='Y')? 'Unlock' : 'Lock').'</span></a></li>';
		$hmenu.='<li><a href="javascript:fwDelete()">Delete</a></li>';
		$hmenu.=((empty($row['c']))? '<li>Comments('.$row['c'].')</li>':'<li><a href="index.php?qur=9M6M1M0M'.$post_id.'M0M0">Comments('.$row['c'].')</a></li>');
		$hmenu.='<li><a href="javascript:fwSetToNews()">Set to News</a></li>';
		$hmenu.=((($row['publish'])=='Y')? '<li><span id="fw_view"><a target="_blank" href="../../index.php?t='.$post_id.'">View post</a></span></li>':'<li><span id="fw_view">View post</span></li>');
		$this->build_head("Edit post",'<script type="text/javascript" src="script/editpost.js"></script><script type="text/javascript">var xid ='.$post_id.';var bbCodeEditorID="content";var maxCodeLength='.$max.';</script>',$hmenu);
		$this->clear_userfiles();
		$us=$this->get_uploadsettings();
		$upload_list=$this->get_uploadlist($us,$post_id);
		include "include/editpost.php";
		$this->build_footer();
}
private function delete_post($post_id)
{
		$query = sprintf("update ((SELECT id AS xid FROM ".PREFIX."post WHERE pid = %u) UNION ALL (SELECT %u AS xid)) as t join ".PREFIX."upload t2 on t.xid = t2.pid set t2.pid = 0",$post_id);
		@$this->con->query($query);
		$query=sprintf("delete t2, t3 from ((SELECT id AS xid FROM ".PREFIX."post WHERE pid = %u) UNION ALL (SELECT %u AS xid)) as t left join ".PREFIX."post t2 on t2.id = t.xid left join ".PREFIX."search t3 on t2.id = (if((t3.pid = 0),t3.cid,t3.pid))",$post_id,$post_id);
		@$this->con->query($query);
		$loc="Location: index.php?qur=2M";
		@header($loc);
}
private function publish($post_id)
{
		$query="SELECT publish FROM ".PREFIX."post WHERE id = $post_id";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['publish']=='Y'){$response='Publish'; $publish='';}
		else{$response='Block'; $publish='Y';}
		$query=sprintf("UPDATE ".PREFIX."post tp, ".PREFIX."search ts SET tp.publish = '$publish', ts.publish = '$publish' WHERE tp.id = %d AND tp.id = ts.pid",$post_id);
        if(@$this->con->query($query)!=false){echo $response;}
        exit;
}
private function lock_post($post_id)
{
		$query=sprintf("SELECT locked FROM ".PREFIX."post WHERE id = %d",$post_id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['locked']=='Y'){$response='Lock'; $lock='';}
		else{$response='Unlock'; $lock='Y';}
        $query=sprintf("UPDATE ".PREFIX."post SET locked = '$lock' WHERE id = %d",$post_id);
        if(@$this->con->query($query)){echo $response;}
        exit;
}
private function edit_post($id)
{
		$title=trim(fw_strip_slashes($_POST["title"]));
		$title=htmlspecialchars(($title));
		$content=trim(fw_strip_slashes($_POST["content"]));
		$content=htmlspecialchars(($content));
		$autolink=(empty($_POST["fw_parseurls"])? 0 : 1);
		$s=fw_linkcount($content,$autolink);
		if($s>$this->site['linkperpost']){fw_message(true,'Error! Maximum '.$this->site['linkperpost'].' URL allowed');exit;}
		$upload_list='';
		$message='';
		if(!$this->verify_uploadcontent($content,$upload_list,$message,$id)){fw_message(true,$message);exit;}
		$content_text=$this->con->real_escape_string(fw_bb2text($content));
		$fid=$_POST["parent"];
		$dt=time();
		$max_size=$this->site['postsize'];
		if((strlen($content)>$max_size)||(strlen($title)>80)){exit;}
		$content=$this->con->real_escape_string($content);
		$title=$this->con->real_escape_string($title);
		$description=trim(fw_strip_slashes($_POST["description"]));
		$tags=trim(fw_strip_slashes($_POST["tags"]));
		$description=htmlspecialchars(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$tags=htmlspecialchars(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){exit;}
		$description=$this->con->real_escape_string($description);
		$tags=$this->con->real_escape_string($tags);
		$query="UPDATE ".PREFIX."post SET fid = %u, title = '%s', content = '%s', description = '%s', keywords = '%s', autolink = $autolink, updated = $dt WHERE id = %d AND pid = 0";
		$query=sprintf($query,$fid,$title,$content,$description,$tags,$id);
		if(!(@$this->con->query($query))){fw_message(true,'Error: '.$this->con->error);exit;}
		$query="UPDATE ".PREFIX."search SET title = '%s', body = '%s', description = '%s', keywords = '%s' WHERE pid = %d";
		$query=sprintf($query,$title,$content_text,$description,$tags,$id);
		@$this->con->query($query);
		if(!empty($upload_list)){$query="UPDATE ".PREFIX."upload SET pid = $id WHERE id IN $upload_list";@$this->con->query($query);}
		fw_message(false,'Data has been successfully updated');
		exit;
}

private function show_list($page,$uid,$sortColumn,$sortDirection,$fid='')
{
        $search='';
        $sortDir=((empty($sortDirection))? 'Desc' : 'Asc');
		$sort_arr=array('tp.id','tp.title','c','tp.updated');
        $sortCol=$sort_arr[$sortColumn];
        if(!empty($_GET['SearchFileString'])){$search=htmlspecialchars(fw_strip_slashes($_GET['SearchFileString']));}
		$hmenu='<li><a href="#" onclick="return fwSelectAll()">Select All</a></li><li><a href="#" onclick="return fwBlockAll(1)">Block Selection</a></li><li><a href="#" onclick="return fwBlockAll(0)">Publish Selection</a></li><li><a href="#" onclick="return fwLockAll(1)">Lock Selection</a></li><li><a href="#" onclick="return fwLockAll(0)">UnLock Selection</a></li><li><a href="#" onclick="return fwDeleteAll()">Delete Selection</a></li>';
        $this->build_head("Post list", '<script type="text/javascript" src="script/editpost.js"></script>', $hmenu);
		$query="SELECT id FROM ".PREFIX."post WHERE pid = 0 AND fid <> 0 AND ";
		if(!empty($uid)){$query.="uid = $uid AND ";}
		if(!empty($fid)){$query.="fid = $fid AND ";}
		$query.="(title LIKE '%%%s%%' OR keywords LIKE '%%%s%%')";
        $result = @$this->con->query(sprintf($query,$this->con->real_escape_string($search),$this->con->real_escape_string($search)));
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);
        $query ="SELECT tp.id, tp.uid, tp.locked, tp.title, tp.updated, tp.publish, IF(ISNULL(tc.cc), 0,tc.cc) AS c, tu.user FROM ".PREFIX."post tp LEFT JOIN ";
		$query.="(SELECT COUNT(id) AS cc, pid FROM ".PREFIX."post WHERE pid <>0 GROUP BY pid) AS tc ON tp.id=tc.pid LEFT JOIN ".PREFIX."user tu ON tp.uid=tu.id WHERE tp.pid = 0 AND tp.fid <> 0 AND ";
		if(!empty($uid)){$query.="tp.uid = $uid AND ";}
		if(!empty($fid)){$query.="tp.fid = $fid AND ";}
		$query.="(tp.title LIKE '%%%s%%' OR tp.keywords LIKE '%%%s%%') GROUP BY tp.id ";
		$query.="ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
		$query=sprintf($query,$this->con->real_escape_string($search),$this->con->real_escape_string($search));
        echo '<iframe name="formSubmit" id="formSubmit" style="display:none;"></iframe><form name="frmList" id="frmList" method="post" target="formSubmit" onsubmit="return false">';
		echo '<table id="list"><tr><td colspan="2" style="width:62%" class="heading">';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M1M1M'.$fid.'"><img src="images/asc.gif" onmouseover="this.src=\'images/asc-h.gif\'" onmouseout="this.src=\'images/asc.gif\'" /></a>';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M1M0M'.$fid.'"><img src="images/dsc.gif" onmouseover="this.src=\'images/dsc-h.gif\'" onmouseout="this.src=\'images/dsc.gif\'" /></a>Title</td>';
		echo '<td width="16%" class="heading">';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M2M1M'.$fid.'"><img src="images/asc.gif" onmouseover="this.src=\'images/asc-h.gif\'" onmouseout="this.src=\'images/asc.gif\'" /></a>';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M2M0M'.$fid.'"><img src="images/dsc.gif" onmouseover="this.src=\'images/dsc-h.gif\'" onmouseout="this.src=\'images/dsc.gif\'" /></a>Comments</td>';
		echo '<td width="8%" class="heading" style="text-align:center;">User</td>';
		echo '<td width="14%" class="heading">';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M3M1M'.$fid.'"><img src="images/asc.gif" onmouseover="this.src=\'images/asc-h.gif\'" onmouseout="this.src=\'images/asc.gif\'" /></a>';
		echo '<a href="index.php?qur=2M6M1M'.$uid.'M3M0M'.$fid.'"><img src="images/dsc.gif" onmouseover="this.src=\'images/dsc-h.gif\'" onmouseout="this.src=\'images/dsc.gif\'" /></a>Modified</td></tr>';
		echo '<tr><td colspan="5"><a title="Remove filter" href="index.php?qur=2M">Post list:</a></td></tr>';
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Approved" src="images/approved.gif" alt="P" />';$class='approved';
            if($row['locked']==='Y'){$src='<img title="Locked" src="images/locked.gif" alt="L" />';$class='lock';}
			if($row['publish']!=='Y'){$src='<img title= "Pending approval" src="images/unpublished.gif" alt="U" />';$class='pending';}
            echo '<td class="checkbox"><input name="SelectItem[]" value="'.$row['id'].'" type="checkbox" /></td><td>'.$src.'<a class="'.$class.'" href="index.php?qur=2M1M'.$row['id'].'">'.$row['title'].'</a></td>';
            echo '<td>'.((empty($row['c']))? 'Comment(0)' : '<a href="index.php?qur=9M6M1M0M'.$row['id'].'M0M0">Comment('.$row['c'].')</a>').'</td>';
			echo '<td style="text-align:center;"><a href="index.php?qur=3M7M'.$row['uid'].'">'.$row['user'].'</a></td>';
            echo '<td>'.gmdate("M d, H:i", $row['updated']).'</td></tr>';
        }

        echo '<tr><td colspan="5"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=2M6M'.($page-1).'M'.$uid.'M'.$sortColumn.'M'.$sortDirection.'M'.$fid.'&SearchFileString='.$search.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=2M6M'.$p.'M'.$uid.'M'.$sortColumn.'M'.$sortDirection.'M'.$fid.'&SearchFileString='.$search.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=2M6M'.($page+1).'M'.$uid.'M'.$sortColumn.'M'.$sortDirection.'M'.$fid.'&SearchFileString='.$search.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');
        echo '</td></tr></table></form>';
        echo '<form id="frmSearchList" name="frmSearchList" onSubmit="return fw_search(\'index.php?qur=2M6M1M0M0M0\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type few characters...' : $search);
        echo '" size="20" onclick="fw_cleartext(this,\'Type few characters...\');">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=2M6M1M0M0M0\');"></form>';
        echo '</div>';
        $this->build_footer();
}
private function show_listy($fid)
{
		$f=array();
		$fs=array();
		$v=array();
		$query="SELECT id, title, parent, cid FROM ".PREFIX."forum ORDER BY position desc LIMIT 0, 200";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){$f[]=$row;}
		foreach($f as $x){
			if($x['parent']==0){
				if(!isset($fs[$x['cid']])){$fs[$x['cid']]='';}
				$fs[$x['cid']].='<option '.(($x['id']==$fid)? 'selected ':'').'value="'.$x['id'].'">|&nbsp;___'.$x['title'].'</option>'.$this->get_childy($x['id'],$f,$v,1,$fid);
			}
		}
		$str='';
		$query="SELECT id, title FROM ".PREFIX."category ORDER BY position Desc LIMIT 0, 50";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){$str.='<option disabled>'.$row['title'].'</option>'.($fs[$row['id']]);}
		if($fs[0]){$str.='<option disabled>No Category:</option>'.$fs[0];}
		unset($f,$fs,$v);
		return $str;
}
private function get_childy($id,&$f,&$v,$n,$fid)
{
		if(in_array($id,$v)){echo 'Database error!';exit;}
		$v[]=$id;
		$str='';
		foreach($f as $x){
			if($x['parent']==$id){
				$str.='<option '.(($x['id']==$fid)? 'selected ':'').'value="'.$x['id'].'">'.str_repeat('|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|___',$n).$x['title'].'</option>'.$this->get_childy($x['id'],$f,$v,$n+1,$fid);
			}
		}
		return $str;
}
private function select_forum($fid)
{
		$cat=array();
		$query="SELECT tf.id, tf.cid, tf.title, tf.locked, tc.title as cattitle FROM ".PREFIX."forum tf left join ".PREFIX."category tc on tf.cid = tc.id ORDER BY tc.id Desc, tf.title LIMIT 0, 100";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			if(!$cat[$row['cid']]){$cat[$row['cid']]=($row['cid'])? '<tr><td colspan="2" class="caption">'.$row['cattitle'].':</td><tr>' : '<tr><td colspan="2" class="caption">No Category:</td><tr>';}
			$cat[$row['cid']].='<tr><td width="25px"><input style="margin:0 0 0 8px;" type="radio" name="forums" '.(($row['id']==$fid)? ' checked' : '').' id="'.$row['id'].'"'.(($row['locked']=='Y')? ' disabled':'').' /></td><td><a id="a'.$row['id'].'" href="javascript:fwCheckBox('.$row['id'].')">'.$row['title'].'</a></td></tr>';
		}
		$list=implode($cat);
		include 'include/forumlist.php';
}
private function block_all($block)
{
		$str='';
		$block=empty($block)? 'Y':'';
		if(is_array($_POST['SelectItem'])){
			for($i=0; $i<count($_POST['SelectItem']); $i++){$str.=(($i==0)? $_POST['SelectItem'][$i] : ', '.$_POST['SelectItem'][$i]);}
			$query="update ".PREFIX."post set publish = '$block' where id in ($str)";
			@$this->con->query($query);
			$query="update ".PREFIX."search set publish = '$block' where pid in ($str)";
			@$this->con->query($query);
			echo '<script>parent.location.reload(true);</script>';
		}
		exit;
}
private function delete_all()
{
		$str='';
		if(is_array($_POST['SelectItem'])){
			for($i=0; $i<count($_POST['SelectItem']); $i++){$str.=(($i==0)? $_POST['SelectItem'][$i] : ', '.$_POST['SelectItem'][$i]);}
			$query ="update ((SELECT id AS xid FROM ".PREFIX."post WHERE pid in ($str)) UNION ALL (SELECT id AS xid FROM ".PREFIX."post WHERE id in ($str))) as t join ".PREFIX."upload t2 on t.xid = t2.pid set t2.pid = 0";
			@$this->con->query($query);
			$query="delete t2, t3 from ((SELECT id AS xid FROM ".PREFIX."post WHERE pid in ($str)) UNION ALL (SELECT id AS xid FROM ".PREFIX."post WHERE id in ($str))) as t left join ".PREFIX."post t2 on t2.id = t.xid left join ".PREFIX."search t3 on t2.id = (if((t3.pid = 0),t3.cid,t3.pid))";
			@$this->con->query($query);
			echo '<script>parent.location.reload(true);</script>';
		}
		exit;
}
private function lock_all($lock)
{
		$str='';
		$lock=empty($lock)? '':'Y';
		if(is_array($_POST['SelectItem'])){
			for($i=0; $i<count($_POST['SelectItem']); $i++){$str.=(($i==0)? $_POST['SelectItem'][$i] : ', '.$_POST['SelectItem'][$i]);}
			$query="update ".PREFIX."post set locked = '$lock' where id in ($str)";
			@$this->con->query($query);
			echo '<script>parent.location.reload(true);</script>';
		}
		exit;
}
private function set_to_news($id)
{
		$query=sprintf("SELECT id FROM ".PREFIX."post WHERE pid = %u",$id);
		$result=@$this->con->query($query);
		$num_rows=@$result->num_rows;
		if($num_rows>0){fw_message(true,'<a href="index.php?qur=9M6M1M0M'.$id.'M0M0"><u>Please remove all comments with this post</u></a>');exit;}
		$query=sprintf("UPDATE ".PREFIX."post tp LEFT JOIN ".PREFIX."search ts ON tp.id = ts.pid SET tp.fid = 0, tp.uid = 0, ts.uid = 0 WHERE tp.id = %u",$id);
		if(@$this->con->query($query)){echo '<script>parent.location.href="index.php?qur=14M1M'.$id.'";</script>';}
		else{fw_message(true,$this->con->error);}
		exit;
}
public function get_query($query='')
{
if($this->validate_user()){
    switch ($query[1]) {
        case "6":
            $this->show_list($query[2],$query[3],$query[4],$query[5],$query[6]);
        break;
        case "7":
            $this->edit_post($query[2]);
        break;
        case "8":
            $this->lock_post($query[2]);
        break;
        case "1":
            $this->show_edit($query[2]);
        break;
        case "2":
            $this->delete_post($query[2]);
        break;
        case "3":
            $this->publish($query[2]);
        break;
		case "4":
			$this->delete_all();
		break;
        case "5":
            $this->log_out();
        break;
        case "9":
            $this->block_all($query[2]);
        break;
        case "10":
            $this->lock_all($query[2]);
        break;
        case "11":
            $this->set_to_news($query[2],$query[3]);
        break;
        default :
            $this->show_list(1,0,0,0);
    }
}
else{if(($query[1]===6)||($query[1]===1)||empty($query[1])){$this->log_in();}}
}
}
?>