<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class clslogin
{
protected $uid;
protected $site;
protected $admin;
protected $con;
function __construct()
{
        $message=$this->connection();
		if((($this->site['blocksite'])&&(!$this->admin))||($message!==true)){header("Location: ../../index.php");exit;}
}
private function connection()
{
        include '../database/config.php';
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return true;
}
private function validate_user()
{
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result=$this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
		$this->is_login();
		$result->free();
}
private function mail_forget_password($email,$name,$uid)
{
		$verify=substr(fw_random(),0,12);
		$dt=time();
		$query=sprintf("INSERT INTO ".PREFIX."tmpuser(uid, email, verify, date) VALUES ($uid, '%s', '%s', $dt)",$this->con->real_escape_string($email),$this->con->real_escape_string($verify));
        if(!$this->con->query($query)){return false;}
		$id=$this->con->insert_id;
		$link=FORUM_URL."gb/user/index.php?id=$id&verify=".md5($verify);
		$from="From: ".$this->default_from()."\r\n";
        $text="Hello ".$name.",\r\nYou or someone else request password reset of your account at: http://".getenv('HTTP_HOST')."\r\nIf you really want to reset your password then please click the following link.\r\n\r\n$link";
		$text.="\r\n\r\nThis link can be used once only and remain active for 48 hours.\r\nIf you are unable to click the above link please copy and paste the personalized link in your browser.\r\n";
        $text.="\r\nThank you.\r\nSite administrator.\r\nhttp://".getenv('HTTP_HOST')."/";
        $text.="\r\n------------------------------------------\r\nThis is an autogenerated email. Please do not reply.";
        return (@mail($email,'Your requested password',$text,$from));
}
private function mail_register_email($email,$name,$uid)
{
        $dt=time();
        $verify=substr(fw_random(),0,12);
		$query=sprintf("INSERT INTO ".PREFIX."tmpuser(uid, email, verify, date) VALUES ($uid, '%s', '%s', $dt)",$this->con->real_escape_string($email),$this->con->real_escape_string($verify));
		if(!($this->con->query($query))){return false;}
		$id=$this->con->insert_id;
        $from=$this->default_from();
        $selfurl = str_replace("www.","", strtolower(getenv("HTTP_HOST")));
        $link='http://'.strtolower(getenv("HTTP_HOST")).DOCROOT.'gb/user/index.php?id='.$id.'&verify='.md5($verify);
		$text="Hello $name,\r\nWelcome to ".$this->site['sitename']."\r\nYou are just one step behind to complete the registration process.\r\nPlease click the following link to confirm your registration.\r\n\r\n$link\r\n\r\n";
        $text.="*This link will remain active for 48 hours.\r\nIf you are unable to click the above link please copy and paste the personalized link in your browser.\r\n\r\n";
        $text.="-----------------------------------\r\nYou receive this email because you (or someone else) has added this email address to $selfurl.\r\n";
        $text.="This is an auto generated email. Please do not reply.";
        return(@mail($email,'Verification required',$text,'From: '.$from));
}
protected function mail_email_change($email,$name,$uid)
{
		$verify=substr(fw_random(),0,12);
		$dt=time();
		$query=sprintf("INSERT INTO ".PREFIX."tmpuser(uid, email, verify, date) VALUES ($uid, '%s', '%s', $dt)",$this->con->real_escape_string($email),$this->con->real_escape_string($verify));
        if(!$this->con->query($query)){return false;}
		$id=$this->con->insert_id;
		$link=FORUM_URL."gb/user/index.php?id=$id&verify=".md5($verify);
		$from="From: ".$this->default_from()."\r\n";
        $text="Hello ".$name.",\r\nPlease click the following link to confirm this email address.\r\n\r\n$link";
		$text.="\r\n\r\n*This link can be used once only and remain active for 48 hours.\r\nIf you are unable to click the above link please copy and paste the personalized link in your browser.\r\n";
        $text.="\r\nThank you.\r\nSite administrator.\r\nhttp://".getenv('HTTP_HOST')."/";
        $text.="\r\n------------------------------------------\r\nThis is an autogenerated email. Please do not reply.";
        return (@mail($email,'Your requested password',$text,$from));
}
protected function verify_user(&$message)
{
		if(($this->site['blocksite']=='Y')&&(empty($this->admin))){include "../gb/include/blocksite.php";exit;}
		if(!empty($_POST['login'])){return($this->login($message));}
		if(!empty($_POST['forget'])){$this->forget($message);return false;}
		if($this->is_login()){return true;}
        if((isset($_POST['register']))&&(!$this->site['blockreg'])){$this->register($message);}
		return false;
}
private function is_login()
{
		if(isset($_COOKIE['fw_login'])&&fw_validate_session($_COOKIE['fw_login'])){
            $login=explode('-',$_COOKIE['fw_login']);
			$id=(int)$login[0];
			$session=$login[1];
            $query=sprintf("SELECT session FROM ".PREFIX."user WHERE id = %u AND level='C'",$id);
            $result=@$this->con->query($query);
			$row =@$result->fetch_array(MYSQL_ASSOC);
            if((!empty($row['session']))&&(md5($row['session'])===$session)){$this->uid=$id;return true;}
		}
		return false;
}
private function exceed_login()
{
        $_SESSION['fw_try']=((isset($_SESSION['fw_try']))? 1+$_SESSION['fw_try'] : 1);
        return($_SESSION['fw_try']>6);
}
private function remote_login()
{
		$message='s';
		if(!$this->is_login()){$this->login($message);}
		echo '<script>parent.fwOnLogin("'.fw_php2javascript($message).'");</script>';exit;
}
private function remote_logout()
{
		@setcookie('fw_login','',(time()-100));
		$query = sprintf("UPDATE ".PREFIX."user set session = '' WHERE id = %u",$this->uid);
		@$this->con->query($query);
		$this->uid='';
		echo '<script>parent.fwOnLogout();</script>';exit;
}
private function login(&$message)
{
        if($this->exceed_login()){$message='<span style="color:red;">Maximum number of login attempt failed! Please restart browser.</span>';return false;}
		$user=fw_strip_slashes(trim($_POST['user']));
        $password=fw_strip_slashes(trim($_POST['password']));
		$staylogin=(isset($_POST['staylogin']))? htmlentities(fw_strip_slashes(trim($_POST['staylogin']))):'';
        if((!fw_validate_username($user))||(!fw_validate_password($password))){$message='<span style="color:red;">Incorrect user name and/or password!</span>';return false;}
        $password=md5($password);
		$query=sprintf("SELECT id FROM ".PREFIX."user WHERE user = '%s' AND password = '%s' AND (level='C')",$this->con->real_escape_string($user),$this->con->real_escape_string($password));
        $result=@$this->con->query($query);
		$num=@$result->num_rows;
        if($num<1){$message='<span style="color:red;">Incorrect user name and/or password!</span>';return false;}
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$_SESSION['fw_try']=0;
        $random=substr(fw_random(),0,12);
		$dt=(($staylogin==='Y')? (time()+3600*24*365) : 0);
        $query=sprintf("UPDATE ".PREFIX."user SET session = '%s' WHERE id = %u",$this->con->real_escape_string($random),$row['id']);
        if(@$this->con->query($query)==false){$message='<span style="color:red;">System error! Please try again later.</span>';return false;}
		if(!@setcookie('fw_login',$row['id'].'-'.md5($random),$dt,DOCROOT,'',false,true)){$message='<span style="color:red;">Sorry! Your browser must be cookie enabled.</span>';return false;}
		$this->uid=(int)$row['id'];
        return true;
}
private function forget(&$message)
{
        $email=fw_strip_slashes(trim($_POST['forgetemail']));
        if(!fw_validate_email($email)){$message='<span style="color:red;">No such email in our database!</span>';return false;}
        $query=sprintf("SELECT id, name, level FROM ".PREFIX."user WHERE email = '%s' AND (level = 'C' or level = 'W')",$this->con->real_escape_string($email));
        $result=@$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if(empty($row['id'])){$message='<span style="color:red;">No such email in our database!</span>';return false;}
        if($row['level']=='W'){
            $message=($this->mail_register_email($email,$row['name'],$row['id'])? '<span style="color:green;">Resend verification email. Please confirm your account.</span>' : '<span style="color:red;">System error! Please  contact site administrator.</span>');
            return false;}
		$message=($this->mail_forget_password($email,$row['name'],$row['id']))? '<span style="color:green;">Password reset link has been send. Please check your email address.</span>':'<span style="color:red;">System error! Please contact site administrator.</span>';
}

private function default_from(){
		$result=@$this->con->query("SELECT defaultfrom FROM ".PREFIX."mailsettings LIMIT 0,1");
		$row = @$result->fetch_array(MYSQL_ASSOC);
		return $row['defaultfrom'];
}
private function register(&$message)
{
		if((empty($_SESSION['fw_captcha_code']))||(md5($_POST['captcha'])!==($_SESSION['fw_captcha_code']))){
            $message='<span style="color:red;">Error! wrong verification code. Please try again.</span>';
            return false;}
		unset($_SESSION['fw_captcha_code']);
		$name=fw_strip_slashes(trim($_POST['name']));
        $user=fw_strip_slashes(trim($_POST['user']));
        $password=fw_strip_slashes(trim($_POST['pw']));
        $email=fw_strip_slashes(trim($_POST['registeremail']));
        if(!fw_validate_user($user,$email)){return false;}
        if(!fw_validate_password($password)){return false;}
		if(!fw_validate_realname($name)){return false;}
		$password=md5($password);
        $dt=time();
		$datelimit=$dt-48*3600;
		$ip=$_SERVER['REMOTE_ADDR'];
        $query=sprintf("SELECT id, ip, user, email, level FROM ".PREFIX."user WHERE email = '%s' OR user = '%s' OR (ip = '%s' AND date > $datelimit) LIMIT 0, 1",$this->con->real_escape_string($email),$this->con->real_escape_string($user),$this->con->real_escape_string($ip));
        $result=@$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if(!empty($row['id'])){
			if($row['email']==$email){
				if($row['user']==$user){
					if($row['level']==='B'){$message='<span style="color:red;">Sorry! you have been banned from this site.</span>';return false;}
					if($row['level']==='C'){$message='<span style="color:red;">You are already registered! Please use <b>Forget password</b> form to recover password.</span>';return false;}
					if($row['level']==='W'){$message='<span style="color:red;">You are already registered. Please use <b>Forget password</b> form to resend verification email.</span>';return false;}
				}
				else{$message='<span style="color:red;">Another user is using this email ID! Please select different one.</span>';return false;}
			}
			else{
				if($row['user']==$user){$message='<span style="color:red;">User <b>'.$user.'</b> already exist! Please select different user name.</span>';return false;}
				else{if(!empty($this->site['blockspam'])){$message='<span style="color:red;">Sorry! New user registration is not possible at this moment.</span>';return false;}}
			}
		}
		if((!empty($this->site['blockspam']))&&(isset($_COOKIE['fw_registered']))){$message='<span style="color:red;">Sorry! New user registration is not possible at this moment.</span>';return false;}
        if(!@setcookie('fw_registered',fw_random(),$dt+3600*48)){$message='<span style="color:red;">Your browser must be cookie enabled to register with this board.</span>';return false;}
		if($this->site['verifyuser']){
			$query=sprintf("INSERT INTO ".PREFIX."user(name, ip, user, email, password, level, date) VALUES ('%s', '%s', '%s', '%s', '%s', 'W', $dt)",$this->con->real_escape_string($name),$this->con->real_escape_string($ip),$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($password));
			if(@$this->con->query($query)){
				$id=$this->con->insert_id;
				$message=($this->mail_register_email($email,$name,$id)? '<span style="color:green;">A verification email has been send. Please confirm your account.</span>' : '<span style="color:red;">System error! Please  contact site administrator.</span>');
			}
			else{$message='<span style="color:red;">System error! Please  contact site administrator.</span>';}
		}
		else{
			$query=sprintf("INSERT INTO ".PREFIX."user(name, ip, user, email, password, level, date) VALUES ('%s', '%s', '%s', '%s', '%s', 'C', $dt)",$this->con->real_escape_string($name),$this->con->real_escape_string($ip),$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($password));
			$message=(@$this->con->query($query))? '<span style="color:green;">Thank you for registering with us, your account has been created. You may now login with your user name and password.</span>' : '<span style="color:red;">System error! Please  contact site administrator.</span>';
		}
		return false;
}
protected function log_out()
{
		@setcookie('fw_login','',(time()-100));
		$query = sprintf("UPDATE ".PREFIX."user set session = '' WHERE id = %u",$this->uid);
		@$this->con->query($query);
		$this->uid='';
		@header("Location: index.php");
		exit;
}
protected function log_in($message='')
{
		$title='Login';
		$menu=$this->get_menu();
		$blockreg=$this->site['blockreg'];
		$scriptfile='<script type="text/javascript" src="../script/login.js"></script>';
		include "include/head.php";
		include "include/login.php";
		include "include/footer.html";
}
protected function get_menu()
{
		if(DOCROOT!=='/'){$menu='<li><a href="http://'.$_SERVER['HTTP_HOST'].'/">Home</a></li>';}
		$menu.='<li><a href="../../index.php">Forum</a></li>';
		if(!empty($this->uid)){$menu.='<li><a href="index.php">UserCP</a></li><li><a href="index.php?query=1M5">Logout</a></li>';}
		return '<ul>'.$menu.'</ul><ul><li><a href="http://ramui.com/forum-script/ramui-forum-script.html">Documentation</a></li><li><a href="http://ramui.com/forum/index.php?f=23">Help</a></li></ul>';
}
protected function clear_userfiles()
{
		$lasthour=time()-3600;
		$result=@$this->con->query(sprintf("SELECT pname FROM ".PREFIX."upload WHERE (pid = 0 AND uid = %u) OR (pid = 0 AND date < $lasthour)",$this->uid));
		while($row = @$result->fetch_array(MYSQL_ASSOC)){@unlink(USER_FILES.'.'.$row['pname']);}
		@$this->con->query(sprintf("DELETE FROM ".PREFIX."upload WHERE (pid = 0 AND uid = %u) OR (pid = 0 AND date < $lasthour)",$this->uid));
}
protected function get_uploadlist($us,$pid='')
{
		$query="SELECT id, name, pid FROM ".PREFIX."upload WHERE (uid = ".$this->uid." AND pid = 0)";
		if($pid){$query.=sprintf(" OR (pid = %u)",$pid);}
		$result=@$this->con->query($query);
		$num_rows=@$result->num_rows;
		$str='<tr><td id="fw_uploadfiles"><table>';
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			$str.='<tr><td class="fw_filename" id="'.$row['id'].'" width="60%">';
			$str.=(($row['pid'])? '*':'').$row['name'].'</td><td style="text-align:center;"><a title="Add to post" class="btn_add" href="javascript:addFileA(\''.addslashes($row['name']).'\')">Add</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a title="Remove from post" class="btn_remove" href="javascript:removeFileA(\''.addslashes($row['name']).'\')">Remove</a>';
			$str.='&nbsp;&nbsp;|&nbsp;&nbsp;<a title="Parmanently delete" class="btn_delete" href="javascript:deleteFileA('.$row['id'].',\''.addslashes($row['name']).'\')">Delete</a></td></tr>';
		}
		$str.='</table></td><td id="fw_notice"><ul><li>Maximum file size: '.$us['size'].'Kb;</li><li>Allowed file type: '.$us['extensions'].';</li><li>Valid file name: A-Z, a-z, 0-9, \'-\', \'_\';</li></ul></td></tr>';
		$str.='<tr><td colspan="2" id="tdUpload">';
		if($num_rows<$us['fpp']){
			$str.='<form name="frmUpload" enctype="multipart/form-data" target="fileSubmit" action="index.php?query=4M1M'.$pid.'" method="POST" onSubmit="return fwCheckSubmit(this,\''.$us['extensions'].'\');">';
			$str.='<input type="hidden" name="MAX_FILE_SIZE" value="'.($us['size']*1024).'" />';
			$str.='<input name="file" type="file" />&nbsp;&nbsp;<input name="submit" type="submit" value="Upload File" /></form>';
		}
		else{$str.='**Please Delete unnecessary files to upload new file';}
		return $str.'</td></tr>';
}
protected function delete_uploadfile($id,$pid='')
{
		$result=@$this->con->query(sprintf("SELECT pname FROM ".PREFIX."upload WHERE id = %u",$id));
		$row = @$result->fetch_array(MYSQL_ASSOC);
		@unlink(USER_FILES.'.'.$row['pname']);
		@$this->con->query(sprintf("DELETE FROM ".PREFIX."upload WHERE id = %u",$id));
		echo '<script>parent.document.getElementById("fw_uploadlist").innerHTML="'.fw_php2javascript($this->get_uploadlist($this->get_uploadsettings(),$pid)).'";</script>';
}
private function get_filecount($pid='')
{
		$query="SELECT id, name FROM ".PREFIX."upload WHERE (uid = ".$this->uid." AND pid = 0)";
		if($pid){$query.=sprintf(" OR (pid = %u)",$pid);}
		$result=@$this->con->query($query);
		return @$result->num_rows;
}
private function upload_exists($n,$pid='')
{
		$query="SELECT id FROM ".PREFIX."upload WHERE ((uid = ".$this->uid." AND pid = 0)";
		if($pid){$query.=" OR (pid = $pid)";}
		$query.=") AND name = '$n'";
		$result=@$this->con->query($query);
		return @$result->num_rows;
}
protected function get_uploadsettings()
{
		$result=@$this->con->query("SELECT* FROM ".PREFIX."filesettings LIMIT 0, 1");
		return @$result->fetch_array(MYSQL_ASSOC);
}
private function upload_file($pid='')
{
		if(!$this->site['allowfile']){exit;}
		$us=$this->get_uploadsettings();
		if($us['fpp']<=$this->get_filecount($pid)){exit;}
		if(!(is_uploaded_file($_FILES["file"]["tmp_name"]))){exit;}
		if($_FILES["file"]["size"] > ($us['size'])*1024){exit;}
		if(!fw_validate_filename(($_FILES["file"]["name"]),$us['extensions'])){echo '<script>alert("Invalid file name or extension!");</script>';return;}
		if($this->upload_exists(($_FILES["file"]["name"]),$pid)){echo '<script>alert("File already exists!");</script>';return;}
		while((!$pname)||(is_file(USER_FILES.'.'.$pname))){$pname=fw_generate_filename();}
		$date=time();
		$size=getimagesize($_FILES["file"]["tmp_name"]);
		if(($size===false)||(!preg_match('/^([a-z0-9_\-]){1,45}+(\.)+(gif|png|jpg|bmp|jpeg)$/i',$_FILES["file"]["name"]))){
			$zip = new ZipArchive;
			if($zip->open(USER_FILES.'.'.$pname,ZipArchive::CREATE) === TRUE){
				if($zip->addFile(($_FILES["file"]["tmp_name"]), ($_FILES["file"]["name"]))){
					$zip->close();
					chmod(USER_FILES.'.'.$pname,0666);
					$filesize=@filesize(USER_FILES.'.'.$pname);
					$query="INSERT INTO ".PREFIX."upload (uid, pname, name, type, filesize, date, compressed) VALUES (%u, '%s', '%s', '%s', %d, $date, 1)";
					$query=sprintf($query,$this->uid,$this->con->real_escape_string($pname),$this->con->real_escape_string($_FILES["file"]["name"]),$this->con->real_escape_string($_FILES["file"]["type"]),$filesize);
					@$this->con->query($query);
				}
				else{$zip->close();}
			}
		}
		else{
			if(($size[0]>$us['width'])||($size[1]>$us['height'])){echo '<script>alert("Max image size w X h = '.$us['width'].' X .'.$us['height'].'");</script>';return;}
			if(@move_uploaded_file(($_FILES["file"]["tmp_name"]),(USER_FILES.'.'.$pname))){
				$query="INSERT INTO ".PREFIX."upload (uid, pname, name, type, filesize, date, compressed) VALUES (%u, '%s', '%s', '%s', %d, $date, 0)";
				$query=sprintf($query,$this->uid,$this->con->real_escape_string($pname),$this->con->real_escape_string($_FILES["file"]["name"]),$this->con->real_escape_string($_FILES["file"]["type"]),($_FILES["file"]["size"]));
				@$this->con->query($query);
			}
		}
		echo '<script>parent.document.getElementById("fw_uploadlist").innerHTML="'.fw_php2javascript($this->get_uploadlist($us,$pid)).'";</script>';
}
protected function verify_uploadcontent(&$content,&$list,&$msg,$id='')
{
		$arr=array();
		$us=$this->get_uploadsettings();
		$match='/\[file\]([a-z0-9_\-\.]){5,50}\[\/file\]/i';
		$x=preg_match_all($match,$content,$arr,PREG_PATTERN_ORDER);
		if($x){
			if($x>$us['fpp']){$msg='Exceed Max. file per post';return false;}
			$arr=array_unique($arr[0]);
			if(count($arr)<$x){$msg='Same file added more than once';return false;}
			foreach($arr as &$a){$a= "'".$this->con->real_escape_string(str_replace('[file]','',str_replace('[/file]','',$a)))."'";}
			$listx=implode(", ",$arr);
			$query=sprintf("SELECT id FROM ".PREFIX."upload WHERE name IN ($listx) AND ((uid = %u AND pid = 0)",$this->uid);
			if($id){$query.=sprintf(" OR (pid = %u)",$id);}
			$query.=")";
			$result=@$this->con->query($query);
			$n=@$result->num_rows;
			if($n<$x){$msg='Unknown file source';return false;}
			$ids=array();
			while($row = @$result->fetch_array(MYSQL_ASSOC)){$ids[]=(int)$row['id'];}
			$list='('.implode(', ',$ids).')';
			if($id){@$this->con->query("UPDATE ".PREFIX."upload SET pid = 0 WHERE pid = $id AND id NOT IN $list");}
		}
		else{if($id){@$this->con->query("UPDATE ".PREFIX."upload SET pid = 0 WHERE pid = $id");}}
		return true;
}
public function get_query($qur)
{
		$message='';
		if($qur[1]=="3"){$this->remote_login();return;}
		if($qur[1]=="4"){$this->remote_logout();return;}
		if($this->verify_user($message)){
			switch ($qur[1]){
				case "1":
					$this->upload_file($qur[2]);
				break;
				case "2":
					$this->delete_uploadfile($qur[2],$qur[3]);
				break;
				default:
					@header("Location: index.php");
			}
		}
		else{
			echo '<script>alert("You have been logged out. Please login again");</script>';return;
		}
}
}
?>